// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from marti_common_msgs:msg/TimeStamped.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "marti_common_msgs/msg/time_stamped.h"


#ifndef MARTI_COMMON_MSGS__MSG__DETAIL__TIME_STAMPED__FUNCTIONS_H_
#define MARTI_COMMON_MSGS__MSG__DETAIL__TIME_STAMPED__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "marti_common_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "marti_common_msgs/msg/detail/time_stamped__struct.h"

/// Initialize msg/TimeStamped message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * marti_common_msgs__msg__TimeStamped
 * )) before or use
 * marti_common_msgs__msg__TimeStamped__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
bool
marti_common_msgs__msg__TimeStamped__init(marti_common_msgs__msg__TimeStamped * msg);

/// Finalize msg/TimeStamped message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
void
marti_common_msgs__msg__TimeStamped__fini(marti_common_msgs__msg__TimeStamped * msg);

/// Create msg/TimeStamped message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * marti_common_msgs__msg__TimeStamped__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
marti_common_msgs__msg__TimeStamped *
marti_common_msgs__msg__TimeStamped__create(void);

/// Destroy msg/TimeStamped message.
/**
 * It calls
 * marti_common_msgs__msg__TimeStamped__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
void
marti_common_msgs__msg__TimeStamped__destroy(marti_common_msgs__msg__TimeStamped * msg);

/// Check for msg/TimeStamped message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
bool
marti_common_msgs__msg__TimeStamped__are_equal(const marti_common_msgs__msg__TimeStamped * lhs, const marti_common_msgs__msg__TimeStamped * rhs);

/// Copy a msg/TimeStamped message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
bool
marti_common_msgs__msg__TimeStamped__copy(
  const marti_common_msgs__msg__TimeStamped * input,
  marti_common_msgs__msg__TimeStamped * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
const rosidl_type_hash_t *
marti_common_msgs__msg__TimeStamped__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
const rosidl_runtime_c__type_description__TypeDescription *
marti_common_msgs__msg__TimeStamped__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
const rosidl_runtime_c__type_description__TypeSource *
marti_common_msgs__msg__TimeStamped__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
marti_common_msgs__msg__TimeStamped__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/TimeStamped messages.
/**
 * It allocates the memory for the number of elements and calls
 * marti_common_msgs__msg__TimeStamped__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
bool
marti_common_msgs__msg__TimeStamped__Sequence__init(marti_common_msgs__msg__TimeStamped__Sequence * array, size_t size);

/// Finalize array of msg/TimeStamped messages.
/**
 * It calls
 * marti_common_msgs__msg__TimeStamped__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
void
marti_common_msgs__msg__TimeStamped__Sequence__fini(marti_common_msgs__msg__TimeStamped__Sequence * array);

/// Create array of msg/TimeStamped messages.
/**
 * It allocates the memory for the array and calls
 * marti_common_msgs__msg__TimeStamped__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
marti_common_msgs__msg__TimeStamped__Sequence *
marti_common_msgs__msg__TimeStamped__Sequence__create(size_t size);

/// Destroy array of msg/TimeStamped messages.
/**
 * It calls
 * marti_common_msgs__msg__TimeStamped__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
void
marti_common_msgs__msg__TimeStamped__Sequence__destroy(marti_common_msgs__msg__TimeStamped__Sequence * array);

/// Check for msg/TimeStamped message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
bool
marti_common_msgs__msg__TimeStamped__Sequence__are_equal(const marti_common_msgs__msg__TimeStamped__Sequence * lhs, const marti_common_msgs__msg__TimeStamped__Sequence * rhs);

/// Copy an array of msg/TimeStamped messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
bool
marti_common_msgs__msg__TimeStamped__Sequence__copy(
  const marti_common_msgs__msg__TimeStamped__Sequence * input,
  marti_common_msgs__msg__TimeStamped__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // MARTI_COMMON_MSGS__MSG__DETAIL__TIME_STAMPED__FUNCTIONS_H_
